# Revenue problem

## Types
G for Generator, D for Duplicator and B for Booster

## How to define de graph data structure
We need a graph data structure with vertices (with revenue rate) and edges (with nothing actually)

Option 1: Adjacent matrix - Matrix of V^2 with true on every match of adjacent vertices - Used when check if 2 vertices are connected
Option 2: Adjacent list - Node contains every adjacent vertices 
Option 3: Edges list - Linked list with all the edges. Used in Many vertices, few adges

## Algorithm
Given a graph
When a set of nodes (generator, duplicator or booster) is provided
Then a highest revenue rate configuration is provided

Probe types:
* Basic: Revenue 50%
* Mining: G1 - G10: Rates from 100% to 300% (120,140,160,180,200,220,240,270,300)
* Revenue - G1 - G?: Rates from X% to Y%
* Boost: G1 - G2: Boosts at rates x2 (?) and x3 (?)
* Duplicator: G1: Duplicates revenue
* Other: G1: ?
 
Calculate revenue:

## Algorithm improvement: Dynamic programming

* Split by probe type (find by DGI, then BG2, and so on...) -> Suboptimal
* Split by group of probes (minimal set of sinergized probes) -> Suboptimal
* Split by cluster of nodes (Take bigger vertex with depth = 2, fill and repeat) -> ???

# Cheatsheet

`cargo test -q --test integration_test -- --show-output`
`RUST_BACKTRACE=1 cargo run`
`cargo run -q`
`cargo test --test <test name>`




# ChatGPT approach

As an AI language model, I cannot write a complete Rust code for you, but I can provide a general approach to solve this problem:

Create a struct for the graph with vertex and edges. Each vertex should have a production ratio and a list of adjacent vertices.
Create a struct for the probes with a type (production or booster), percentage, and position (vertex).
Create a function to calculate the total production of the graph given a set of probes. This function should iterate over all vertices in the graph, apply the production probes to the corresponding vertices, and apply the booster probes to the adjacent vertices.
Create a function to generate all possible probe combinations. This function should iterate over all vertices in the graph, generate all possible production probe percentages for each vertex, and generate all possible booster probe positions for each vertex.
Create a function to find the probe combination that maximizes the total production. This function should call the calculate total production function for each probe combination generated by the previous function and return the combination that produces the highest total production.
Here's a sample Rust code to get you started:

```rust
struct Vertex {
    production_ratio: f32,
    adj_vertices: Vec<usize>,
}

struct Probe {
    probe_type: String,
    percentage: f32,
    position: usize,
}

struct Graph {
    vertices: Vec<Vertex>,
    probes: Vec<Probe>,
}

fn calculate_total_production(graph: &Graph) -> f32 {
    // iterate over all vertices in the graph
    // apply production probes to the corresponding vertices
    // apply booster probes to the adjacent vertices
    // calculate the total production and return it
}

fn generate_all_probe_combinations(graph: &Graph) -> Vec<Vec<Probe>> {
    // iterate over all vertices in the graph
    // generate all possible production probe percentages for each vertex
    // generate all possible booster probe positions for each vertex
    // return all possible probe combinations
}

fn find_best_probe_combination(graph: &Graph) -> Vec<Probe> {
    let all_probe_combinations = generate_all_probe_combinations(graph);
    let mut best_probe_combination = Vec::new();
    let mut max_production = 0.0;
    for probe_combination in all_probe_combinations {
        let production = calculate_total_production(&Graph {
            vertices: graph.vertices.clone(),
            probes: probe_combination.clone(),
        });
        if production > max_production {
            max_production = production;
            best_probe_combination = probe_combination;
        }
    }
    best_probe_combination
}
```

Note that this is just a sample code and you may need to modify it according to your specific needs.
